package com.fp.persistence.pcustomer.company;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**
 * Clase que implementa la entidad de Hibernate que hace referencia a la tabla
 * TCUSTNOTARYOFFICE
 */
@Entity(name = "TcustNotaryOffice")
@Table(name = "TCUSTNOTARYOFFICE")
public class TcustNotaryOffice extends com.fp.dto.AbstractDataTransport implements
        Serializable, HibernateBean, Cloneable, Log {

    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;
    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;
    /**
     * Clave primaria de la Entidad TcustNotaryOffice
     */
    @Id
    @Column(name = "PERSONCODE", nullable = false, updatable = false)
    private Integer pk;

    /**
     * Contructor por defecto
     */
    public TcustNotaryOffice() {
    }

    /**
     * Contructor de TcustNotaryOffice
     *
     * @param pPk Clave Primaria del entity
     */
    public TcustNotaryOffice(Integer pPk) {
        this();
        pk = pPk;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     *
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TcustNotaryOffice
     */
    public static TcustNotaryOffice find(EntityManager pEntityManager, Object pKey) throws Exception {
        TcustNotaryOffice obj = pEntityManager.find(TcustNotaryOffice.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TcustNotaryOffice
     *
     * @return El objeto que referencia a la Clave primaria de TcustNotaryOffice
     */
    public Integer getPk() {
        return pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TcustNotaryOffice
     *
     * @param pPk El objeto que referencia a la nueva Clave primaria de
     * TcustNotaryOffice
     */
    public void setPk(Integer pPk) {
        pk = pPk;
    }

    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TcustNotaryOffice)) {
            return false;
        }
        TcustNotaryOffice that = (TcustNotaryOffice) rhs;
        if (this.getPk() == null || that.getPk() == null) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementación del metodo hashCode de la la entidad TcustNotaryOffice
     *
     * @return el hashCode la instancia
     */
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /**
     * Implementación toString
     */
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if (name.compareTo("hashValue") == 0 || name.compareTo("serialVersionUID") == 0) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /**
     * Implementación de la creación de un bean en blanco TcustNotaryOffice
     */
    public Object createInstance() {
        TcustNotaryOffice instance = new TcustNotaryOffice();
        return instance;
    }

    /**
     * Clona la entidad TcustNotaryOffice
     *
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    public Object cloneMe() throws CloneNotSupportedException {
        TcustNotaryOffice p = (TcustNotaryOffice) this.clone();
        return p;
    }
}
